﻿using Harmony;
using System.Reflection;
using UnityEngine;

public class UnrestrictedBuilding : Mod
{
    HarmonyInstance instance;
    public void Start()
    {
        instance = HarmonyInstance.Create("fr.tekgamer.unrestrictedbuilding");
        instance.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("Mod UnrestrictedBuilding has been loaded!");
    }

    public void OnModUnload()
    {
        instance.UnpatchAll();
        Debug.Log("Mod UnrestrictedBuilding has been unloaded!");
    }
}

[HarmonyPatch(typeof(ConstructionGhost))]
[HarmonyPatch("UpdateProhibitionType")]
internal class Patch_ConstructionGhost
{
    public static bool Prefix(ConstructionGhost __instance)
    {
        Traverse.Create(__instance).Field("m_ProhibitionType").SetValue(ConstructionGhost.ProhibitionType.None);
        return false;
    }
}

[HarmonyPatch(typeof(Construction))]
[HarmonyPatch("SetUpperLevel")]
internal class Patch_Construction
{
    public static bool Prefix(Construction __instance, bool set, int level)
    {
        Traverse.Create(__instance).Field("m_UpperLevel").SetValue(set);
        Traverse.Create(__instance).Field("m_Level").SetValue(0f);
        MethodInfo onsetupperlevel = AccessTools.Method(__instance.GetType(), "OnSetUpperLevel");
        onsetupperlevel.Invoke(__instance, new object[] { (set) });
        return false;
    }
}